/**
  Example program to demonstrate simple kernel threads.
  Orion Sky Lawlor, olawlor@acm.org, 2006/02/03 (Public Domain)
*/
#include <stdio.h>
#include "osl/porthread.h"
#include "osl/porthread.cpp"

volatile int delay;

void do_work(int t,int i) {
	if (t>0) printf("            ");
	printf("%c%d," ,'a'+t,i); fflush(stdout);
	for (delay=0;delay<1000*1000;delay++) {}
	printf("%c%d\n",'A'+t,i); fflush(stdout);
	for (delay=0;delay<1000*1000;delay++) {}
}

void thread_routine(void *arg) {
	int threadNo=(int)arg;
	for (int i=0;i<10;i++) {
		do_work(threadNo,i);
	}
	printf("Thread %c done\n",'A'+threadNo);
}

int main() {
	porthread_t a=porthread_create(thread_routine,(void *)0);
	porthread_t b=porthread_create(thread_routine,(void *)1);
	printf("Done creating threads\n");
	return 0;
}
